%define anolis_release 2
Name: liburing
Version: 2.3
Release: %{anolis_release}%{?dist}
Summary: Linux-native io_uring I/O access library
License: (GPLv2 with exceptions and LGPLv2+) or MIT
Source0: https://brick.kernel.dk/snaps/%{name}-%{version}.tar.gz
URL: https://github.com/axboe/liburing
BuildRequires: gcc
BuildRequires: make

# Begin: Anolis customized patches
Patch1001: 1001-Add-percpu-io-sq-thread-support.patch
Patch1002: 1002-support-us-granularity-of-io_sq_thread_idle.patch
Patch1003: 1003-add-IORING_ENTER_SQ_SUBMIT_ON_IDLE-flag.patch
Patch1004: 1004-Add-a-test-for-sqpoll-sq_thread_idle_us-mode.patch
Patch1005: 1005-test-io_uring_passthrough-skip-if-kernel-doesn-t-sup.patch
Patch1006: 1006-test-io_uring_passthrough-fix-iopoll-test.patch
Patch1007: 1007-test-io_uring_passthrough-cleanup-invalid-submission.patch
Patch1008: 1008-test-io_uring_passthrough-skip-test-if-bit-sqe-cqe-s.patch
# End: Anolis customized patches

%description
Provides native async IO for the Linux kernel, in a fast and efficient
manner, for both buffered and O_DIRECT.

%package devel
Summary: Development files for Linux-native io_uring I/O access library
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
This package provides header files to include and libraries to link with
for the Linux-native io_uring.

%prep
%autosetup -p1

%build
%set_build_flags
./configure --prefix=%{_prefix} --libdir=/%{_libdir} --libdevdir=/%{_libdir} --mandir=%{_mandir} --includedir=%{_includedir}

%make_build

%install
%make_install

%generate_compatibility_deps

%files
%dir %{abidir}
%attr(0755,root,root) %{_libdir}/liburing.so.*
%attr(0755,root,root) %{abidir}/liburing.dump
%license COPYING

%files devel
%{_includedir}/liburing/
%{_includedir}/liburing.h
%{_libdir}/liburing.so
%exclude %{_libdir}/liburing.a
%{_libdir}/pkgconfig/*
%{_mandir}/man2/*
%{_mandir}/man3/*
%{_mandir}/man7/*

%changelog
* Tue Jun 20 2023 Joseph Qi <joseph.qi@linux.alibaba.com> - 2.3-2
- update io_uring_passthrough testcase

* Thu Dec 1 2022 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> - 2.3-1
- upgrade to 2.3 and add anolis liburing features

* Wed Oct 19 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.1-2
- optimise spec file

* Mon Apr 18 2022 gcdota930915 <taifu.gc@alibaba-inc.com> - 2.1-1
- Init from upstream version 2.1
